#!/usr/bin/ruby -Ke
# Ruby/Gtkˤ2ch֥饦 ver 0.03
# ջ  haruyama@unixuser.org
# $Id: 2ch.rb,v 1.7 2001/11/27 17:36:45 haruyama Exp $

require 'gtk'
require 'kconv'
require 'net/http'
begin
require 'zlib'
rescue LoadError
  STDERR.print "ruby-zlibޤǤ\ngzipǰ̤줿ȥ꡼򰷤ȤǤޤ\nߤread.cgiλͤǤgzipǰ̤줿ȥ꡼Τߤ󶡤褦Ǥ\nλޤ\n"
  exit
end


#

# proxyȤʤ
# $proxy_addr = "proxy.addr..."  #ۥ̾IPɥ쥹ʸ
# $proxy_port = 8080

#եȤ
Gtk::RC.parse_string <<EOS
style "default"
{
  fontset = "-mona-gothic-medium-r-normal--14-*"
}
widget_class "*" style "default"
EOS

style = Gtk::Style.new
$font = style.font

$font_height = 14

#ThreadƤ򸫤Box礭
$view_width = 600
$view_height = 600
#Thread򤹤Box礭
$select_width = 300
$select_height = 600

base = ENV["HOME"]+ "/.2ch_ruby_gtk/"
tmp = base + "board_info"

def decode_html_escape_char(str)
  if str 
  #ȴ
    str.gsub! "&gt;", ">"
    str.gsub! "&lt;", "<"
    str.gsub! "&amp;", "\""
    str.gsub! "&.+?;", " "      
  end
  return str
end

#ThreadƤ򸫤Box
class ViewVBox < Gtk::VBox

  def set_file(file)
    @start = 1
    @view_num = 100
    @file = file
    
    @size=0
    while @file.gets
      @size+=1
    end
    @file.rewind

    self.set_sw
  end

  def set_sw
    if @sw
      self.remove @sw
    end
    @sw=Gtk::ScrolledWindow.new(nil,nil)
    @sw.set_usize $view_width, $view_height      
    self.pack_start @sw
    @vbox_view = self.make_view
    @sw.add_with_viewport @vbox_view
    @sw.show_all
  end

  def initialize(title)
    super(false,0)
    @title = title

    @start = 1
    @view_num = 100

    @size = 0
    @file = nil
    @mbar = Gtk::MenuBar.new
    @filemitem = Gtk::MenuItem.new('File')
    @filemenu = Gtk::Menu.new
    @quit_item = Gtk::MenuItem.new('Quit')
    @filemenu.add @quit_item
    @filemitem.set_submenu @filemenu
    @mbar.append @filemitem
    
    @prev_item = Gtk::MenuItem.new('Prev')
    @mbar.append @prev_item
    @next_item = Gtk::MenuItem.new('Next')
    @mbar.append @next_item

    @new_item = Gtk::MenuItem.new('ǿ')
    @mbar.append @new_item
    self.pack_start @mbar, false, false, 0
    @sw=Gtk::ScrolledWindow.new(nil,nil)
    @sw.set_usize $view_width, $view_height
    self.pack_start @sw

    @quit_item.signal_connect('activate'){
      exit
    }
    @next_item.signal_connect('activate'){
      if @file == nil
	return
      end
      self.set_start(@start+@view_num)
      self.set_sw
    }

    @prev_item.signal_connect('activate'){
      if @file == nil
	return
      end
      self.set_start(@start-@view_num)
      self.set_sw
    }

    @new_item.signal_connect('activate'){
      if @file == nil
	return
      end
      self.set_start(@size-@view_num+1)
      self.set_sw
    }

    self.set_item
  end

  def set_item
    if @file == nil
      @prev_item.set_sensitive false
      @next_item.set_sensitive false
      @new_item.set_sensitive false
      return
    else
      if @view_num < @size
	  @new_item.set_sensitive true
      else
	  @new_item.set_sensitive false
      end
    end

    

    if @start > 1
      @prev_item.set_sensitive true
    else
      @prev_item.set_sensitive false
    end

    if @start+@view_num < @size
      @next_item.set_sensitive true
    else
      @next_item.set_sensitive false
    end
  end

  def set_start (start)
    if  start < @size
      if start+@view_num < 1
	@start = 1
      else
	@start = start
      end
    end
  end

  def set_view_num(num)
    if num > 0
      @view_num = num
    end
  end

  def make_view  
    if @file == nil
      return
    end
    @file.rewind
    vbox_view = Gtk::VBox.new(false,0)
    if @view_num <= 0
      return
    end
    
    i=1
    j=0

    while line=@file.gets
      if /^(?:\+OK|-INCR)\s+(\d+)/ =~ line
	next
      end

      if i< @start
	i+=1
	next
      end

      line.strip!

      line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)

      (name,mailto,date_id,body,title)=line.split(/<>/)
      name=decode_html_escape_char(name)
      body=decode_html_escape_char(body)


      frame = Gtk::Frame::new("#{i}")
      frame.set_label_align(0, 0)
      frame.border_width(1)
      vbox_view.pack_start frame
      table = Gtk::Table.new(2,2,false)
      frame.add table

      name.gsub!("<.+?>","")

      if mailto != ""
	name_label = Gtk::Button.new(name)
	tooltips = Gtk::Tooltips::new()
	tooltips.set_tip(name_label,mailto,"")
      else
	name_label = Gtk::Label.new(name)
      end
      table.attach name_label,0,1,0,1,0,0
      date_id_label =  Gtk::Label.new(date_id)
      table.attach date_id_label,1,2,0,1,0,0
      
      lines  = body.split("<br>")
      text = Gtk::Text.new
      text.set_word_wrap false
      table.attach text,0,2,1,2

      tmp = 1
      lines.each { |line|
	while true
	  if /(.*)<a.*?>(.*)<\/a>(.*)/ =~ line
	    
	    line = $1+$2+$3
	    next
	  end
	  text.insert nil,nil,nil, line + "\n"

	  if $font.string_width(line) > $view_width
	    tmp+=1
	  end
	  break
	end
      }

      text.set_usize $view_width,(lines.size+tmp)*$font_height
      
      j+=1
      i+=1
      if j>=@view_num
	break
      end
    end

    self.set_item
    return vbox_view
  end
end 

#åɤ
class Thread2ch
  def initialize(title,url)
    @title = title
    @url = url
    #    @filename= nil
    @file= nil
    @size= 0
    @num_of_statement= 0
  end

  def get_title
    return @title
  end

  def get_url
    return @url
  end

  def get_file
    return @file
  end

  def set_file(file)
    @file = file
  end

  def set_size(size)
    @size = size
  end

  def get_size
    return @size 
  end


  def set_num_of_statement(num)
    @num_of_statement = num
  end

  def get_num_of_statement
    return @num_of_statement
  end

end

#Ĥ
class Board
  def initialize(title,url)
    @title = title
    @url = url
    @filename = nil
# @file=nil
  end

  def set_filename(filename)
    @filename = filename
  end

  def get_title
    return @title
  end

  def get_url
    return @url
  end

end

#ѤTreeItem
class BoardTreeItem < Gtk::TreeItem
  def initialize(title,board)
    super(title)
    @board=board
    @num_of_thread=0
    @subtree=nil
  end
  def get_board
    return @board
  end

  def set_num_of_thread(num)
    @num_of_thread=num
  end
  def get_num_of_thread
    return @num_of_thread
  end

  def set_subtree(subtree)
    if @subtree

      @subtree.clear_items 0,@num_of_thread
    end
    @subtree=subtree
    super
  end
end

#ThreadѤTreeItem
class ThreadTreeItem < Gtk::TreeItem
  def initialize(title,thread)
    super(title)
    @thread=thread
  end
  def get_thread
    return @thread
  end
end

class SelectionVBox < Gtk::VBox
  def initialize(base,board_hash,category_array,view)
    super(false,0)
    @view=view
    @base = base
    @category_array = category_array
    @board_hash = board_hash
    
    @hbox = Gtk::HBox.new(false,0)

    @combo = Gtk::Combo.new
    @combo.entry.set_editable(false)
    @combo.set_popdown_strings(@category_array)

    @hbox.pack_start @combo

    @button = Gtk::Button.new("")
    @hbox.pack_start @button,nil
    self.pack_start @hbox,nil

    @button.signal_connect('clicked'){
      self.set_sw
    }

    @http_header = {}
    @http_header["Accept-Encoding"]="gzip"
  

    self.set_sw
  end
  
  def set_sw
    if @sw
      self.remove @sw
    end
    @sw = tree_set(@board_hash[@combo.entry.get_text])
    self.pack_start @sw      
    @sw.show_all
  end

  def tree_set(array)
    @tree = Gtk::Tree.new
    @tree_size=0

    sw =  Gtk::ScrolledWindow.new()
    sw.set_usize $select_width,$select_height
    sw.add_with_viewport @tree   

    @tree.clear_items 0,@tree_size
    @tree_size=0
    array.each{ |board|
      @tree_size+=1

      item = Gtk::BoardTreeItem.new(board.get_title,board)
      item.signal_connect('select') { 
	get_board_subject(item)
      }
      @tree.append item
    }
    @tree.show_all

    return sw
  end

#Ŭ̥饹ʬΥͽ
  def get_thread(thread)
    url = thread.get_url      
    host,port,path = parse_url(url)
    filename = @base + "thread/"+ host + "_" + "#{port}" + "_" + path.gsub("/","_")

    file = thread.get_file
    if file 
      file.rewind
    else
      if File.exist?(filename)
	file = open( filename, 'w+' )
	begin
	  file = Zlib::GzipReader.new(file)
	rescue  
	  # gzipǤʤ
	end
      end
    end


    size =0
    num_of_statement=0

    append = nil
    if file 
      file.each{ |line|
	line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)
	if  /^(?:\+OK|-INCR)\s+(\d+)/ =~ line
	  size+=Integer($1)
	else
	  num_of_statement+=1
	end
      }
      append = true
    end

    path += "?raw=#{num_of_statement}.#{size}"

    tmp_filename = filename+"_tmp"
    tmp_file = self.http_get_file(host,port,path,tmp_filename)
    if tmp_file ==nil
      STDERR.print "threadեμ˼Ԥޤ\n"
      return
    end
    
    line= tmp_file.gets
    line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)
    if /^\+OK/ =~ line
      
      tmp_file.rewind

      if file 
	file.rewind

	# fileʤ餺gzipǰ̤ƤȤϤʤΤ
	# ݤʤȤ򤹤
	# ޤ GzipReaderˤrewindϤäƤseekϤʤ
	# (gzipΥեåΤ)

	tmp2_filename = filename+"_tmp2"	
	w_file = open(tmp2_filename,"w")

	w_file = Zlib::GzipWriter.new(w_file)
	
	w_file.write  file.read
	w_file.write  tmp_file.read
	
	w_file.close
	
	tmp_file.close
	
	file.close

	File.rename(tmp2_filename,filename)

	File.unlink(tmp_filename)
	file =  open(filename,"r+")

	file = Zlib::GzipReader.new(file)
      else
	tmp_file.close
	File.rename(tmp_filename,filename)
	file =  open(filename,"r+")
	begin
	  file = Zlib::GzipReader.new(file)
	rescue
	end
      end
    elsif  /^\-INCR/ =~ line
      if file
	file.close
      end
      tmp_file.close
      File.rename(tmp_filename,filename)
      file =  open(filename,"r+")
      begin
	file = Zlib::GzipReader.new(file)
      rescue
      end
    else
      p line
      STDERR.print "threadե˰۾郎ޤ\n"
      return 
    end

    thread.set_file(file)
    @view.set_file(file)

  end

#Ŭ̥饹ʬΥͽ
  def parse_url(url)
    if %r!^http://(.*?)(?::(\d+))?(/.*)?$! =~  url
      host = $1
      if $2
	port = Integer($2)
      else
	port = 80
      end
      path = $3
    end
    return host,port,path
  end

#Ŭ̥饹ʬΥͽ
  def http_get_file(host,port,path,filename)
    begin

      file = open( filename, 'w+' )

    rescue 
      STDERR.print "#{filename}ޤǤ\n"    
      return
    end
    begin

      Net::HTTP.start(host,port,$proxy_addr,$proxy_port){ |http|
	response , = http.get(path,@http_header)
	file.write response.body
	file.rewind
	if  "gzip" == response['Content-Encoding']
	  file=Zlib::GzipReader.new(file)
	end
      }
    rescue 
      #      եμ˼
      return nil
    end
    return file
  end

#Ŭ̥饹ʬΥͽ
  def get_board_subject(item)

    board = item.get_board
    url = board.get_url
    host,port,path = parse_url(url)
    filename = @base + "subject/"+ host + "_" + "#{port}" + "_" + path.gsub("/","_")

#TODO: ¸ߥå ɬ?

    path2 = path + "subject.txt"

    file=self.http_get_file(host,port,path2,filename)

    if file == nil
      STDERR.print "subjectեμ˼Ԥޤ\n"
      return
    end
    board.set_filename(filename)

    subtree = Gtk::Tree.new
    item.set_subtree subtree
    
    i=0
    url = "http://" + host + "/test/read.cgi" + path


    file.each{ |line|

      line.chop!
      line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)


      if /(.*)<>(.*)/ =~ line
	title = decode_html_escape_char($2)
	thread = Thread2ch.new(title,url+$1.gsub("\.dat$","")+"/")
      else
	return
      end
      thread_item = Gtk::ThreadTreeItem.new(title,thread)
      thread_item.signal_connect('select') { 
	get_thread(thread)
      }
      subtree.append thread_item
      thread_item.show
      i+=1      
    }
    item.set_num_of_thread(i)
    file.close
    item.show_all
  end
end

if File.exist?(tmp)
  file = open(tmp)
else
  STDERR.print "not found: #{tmp}\n"
end

board_hash = Hash.new
category_array = []
while line = file.gets
  line.chop!
  line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)


  if /C\s(.*)/ =~ line
    category = $1.strip
    category_array.push category
    board_hash[category] = []
  elsif  /B\s(\S*)\s(.*)/ =~ line
    board = Board.new($2.strip,$1)
    board_hash[category] << board
  end
end

window = Gtk::Window.new(Gtk::WINDOW_TOPLEVEL)
window.set_title("Ruby/Gtkˤ2ch֥饦 ver 0.03")
hbox = Gtk::HBox.new(false,0)

vvbox = ViewVBox.new("")
svbox = SelectionVBox.new(base,board_hash,category_array,vvbox)

hbox.pack_start svbox,nil

hbox.pack_start vvbox
window.add hbox

window.show_all
window.signal_connect("destroy") do destroy end

Gtk.main
